<!-- eslint-disable no-unused-expressions -->
<template>
    <form @submit.prevent="submit()">
      <v-card>
        <v-card-title>
          <h2 class="subtitle-1">
            {{ inventory ? `Update` :`Record` }} inventory details
          </h2>
          <v-spacer></v-spacer>
          <v-btn
            icon
            small
            color="red"
            @click="$emit('closed')"
          >
            <v-icon small color="red">mdi-close</v-icon>
          </v-btn>
        </v-card-title>

        <v-divider></v-divider>

        <v-card-text class="pt-5">
          <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Product Name"
            v-model="productName"
            required
          ></v-text-field>
          <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Product Code"
            v-model="sku"
            required
          ></v-text-field>
          <v-select
            :items="categories"
            label="Product Category"

            outlined
            dense
            class=""
            required
            ></v-select>
            <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Selling Price"
            v-model="price"
            required
          ></v-text-field>
          <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Buying Price"
            v-model="cost"
            required
          ></v-text-field>
          <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Quantity"
            v-model="quantity"
            required
          ></v-text-field>
          <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Supplier"
            v-model="supplier"
            required
          ></v-text-field>

          <v-textarea
            outlined
            class="body-2"
            label="Description"
            v-model="description"
            required
          ></v-textarea>
        </v-card-text>

        <v-card-actions class="px-4 pb-5">
          <v-btn
            block
            large
            type="submit"
            color="primary"
            class="caption font-weight-bold no-transform"
            :dark="!loading"
            :loading="loading"
            :disabled="loading"
          >
            {{ inventory ? 'Update' : 'Save' }} Inventory Details
          </v-btn>
        </v-card-actions>
      </v-card>
    </form>
</template>

<script>
/* eslint-disable vue/no-mutating-props */
// eslint-disable-next-line import/extensions
// import Role from '../../../../libs/roles/Role';
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex';

export default {
  props: [
    'inventory',
    'dialog',
  ],

  data() {
    return {
      loading: false,
      // roleObj: new Role(),
      show: false,
      error: null,
      productName: '',
      sku: '',
      category: '',
      cost: null,
      price: null,
      quantity: null,
      // status: 'Active',
      supplier: '',
      description: '',

    };
  },

  mounted() {
    const { role } = this;
    // this.setRoleObj(this.role);
  },

  computed: {
    // errors() {
    //   return this.roleObj.form.errors;
    // },
    categories() {
      const data = ['Tablets', 'Syrup', 'Powder', 'Electronics'];
      return data;
    },

  },

  methods: {
    ...mapActions(['axiosPostRequest']),

    submit() {
      if (!this.loading) {
        this.loading = true;
        const payload = {
          productName: this.productName,
          sku: this.sku,
          category: this.category,
          cost: this.cost,
          price: this.price,
          quantity: this.quantity,
          status: 'Active',
          supplier: this.supplier,
          description: this.description,
        };

        // eslint-disable-next-line no-unused-expressions
        !this.inventory ? this.store(payload) : this.update(payload);
      }
    },

    async store(payload) {
      const fullPayload = {
        params: payload,
        endpoint: '/inventory',
      };
      try {
        const res = await this.axiosPostRequest(fullPayload);
        console.log('add', res);
        // this.notification = res.status === 200 ? 'Login successful' : res.data.message;
        // const { token } = res.data;

        // this.setAccessToken(token);

        // localStorage.setItem('jwtToken', token);

        // this.actionClass = res.status === 200 ? 'success' : 'error';
        // this.$router.push('/');
      } catch (error) {
        // this.notification = 'Login failed. Contact the admin';
        // this.actionClass = 'error';
        return error.response;
      }
    },

    update() {
      this.roleObj.update(this.role.id)
        .then(response => {
          // flash(response)
          this.$emit('updated');
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
};
</script>
